/*
 *  sudoku.c
 *  simu_anneal
 *
 *  Created by wei sun on 2/13/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include <stdio.h>
#include <math.h>
#include <time.h>
#include <stdlib.h>
#include "nrutil.h"
#include "common_lib.h"
#include "sudoku_lib.h"

int main(void)
{
	int i, j, N=9;
	int **dm, **im;
	time_t sec_s;
	time_t sec_e;
	sec_s = time(NULL);

	dm=imatrix(1,N,1,N);
	im=imatrix(1,N,1,N);
	
	// initial the matrix, fill the given cell first
	for (i=1;i<=N;i++) {
		for (j=1;j<=N;j++) { dm[i][j]=0; im[i][j]=0; }
	}
	
	dm[1][1]=5; dm[1][2]=3; dm[1][5]=7;
	dm[2][1]=6; dm[2][4]=1; dm[2][5]=9; dm[2][6]=5;
	dm[3][2]=9; dm[3][3]=8; dm[3][8]=6;
	dm[4][1]=8; dm[4][5]=6; dm[4][9]=3;
	dm[5][1]=4; dm[5][4]=8; dm[5][6]=3; dm[5][9]=1;
	dm[6][1]=7; dm[6][5]=2; dm[6][9]=6;
	dm[7][2]=6; dm[7][7]=2; dm[7][8]=8;
	dm[8][4]=4; dm[8][5]=1; dm[8][6]=9; dm[8][9]=5;
	dm[9][5]=8; dm[9][8]=7; dm[9][9]=9;

	im[1][1]=1; im[1][2]=1; im[1][5]=1;
	im[2][1]=1; im[2][4]=1; im[2][5]=1; im[2][6]=1;
	im[3][2]=1; im[3][3]=1; im[3][8]=1;
	im[4][1]=1; im[4][5]=1; im[4][9]=1;
	im[5][1]=1; im[5][4]=1; im[5][6]=1; im[5][9]=1;
	im[6][1]=1; im[6][5]=1; im[6][9]=1;
	im[7][2]=1; im[7][7]=1; im[7][8]=1;
	im[8][4]=1; im[8][5]=1; im[8][6]=1; im[8][9]=1;
	im[9][5]=1; im[9][8]=1; im[9][9]=1;


	printf("\n*** Initial Given Values ***\n");
	for (i=1;i<=N;i++) {
		for (j=1;j<=N;j++) { printf("%d\t", dm[i][j]); }
		printf("\n");
	}
	printf("\n*** Index Matrix ***\n");
	for (i=1;i<=N;i++) {
		for (j=1;j<=N;j++) { printf("%d\t", im[i][j]); }
		printf("\n");
	}

	// initial the matrix, fill the non-given cell by random permutation
	fill_sudoku(dm);

	printf("\n*** Filled Non-Given Values Randomly ***\n");
	for (i=1;i<=N;i++) {
		for (j=1;j<=N;j++) { printf("%d\t", dm[i][j]); }
		printf("\n");
	}

	// find solution
	sudoku(dm, im);
	
	// print out the solution
	printf("\n*** System Frozen ***\n");
	printf("Final result:\n");
	for (i=1;i<=N;i++) {
		for (j=1;j<=N;j++) { printf("%d\t", dm[i][j]); }
		printf("\n");
	}
	free_imatrix(dm,1,N,1,N);
	free_imatrix(im,1,N,1,N);
	sec_e = time(NULL);
	printf("The total time spent is %ld\n", sec_e-sec_s);
	return 0;
}

